import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class MainCollections
{
    public static Collection<Vertex> mainSet() {
        Set<String> set = new HashSet<>(); //diamond operator since Java 7
        
        set.add("Hello");
        set.add("World");
        
        System.out.println(set.toString() + "\n");
        
        //-----------------------------------------------
        
        Set<Vertex> mnozina = new HashSet<>();
        
        System.out.println("Pocet prvkov: " + mnozina.size());
        
        Vertex vertex = new Vertex(10, 10);
        mnozina.add(vertex);
        System.out.println("Pocet prvkov: " + mnozina.size() + ", konkretne: " + mnozina.toString());
        //toString na kolekciach: [...]
        
        mnozina.add(vertex);
        System.out.println("Pocet prvkov: " + mnozina.size() + ", konkretne: " + mnozina.toString());
        
        Vertex vertexDruhy = new Vertex(10, 10);
        mnozina.add(vertexDruhy);
        System.out.println("Pocet prvkov: " + mnozina.size() + ", konkretne: " + mnozina.toString());
        //zakomentovat/odkomentovat equals na Vertex a vsimnut si rozdiel
        
        Vertex vertexTreti = new Vertex(2, 2);
        mnozina.add(vertexTreti);
        
        
        mnozina.remove(vertex);
        System.out.println("Pocet prvkov: " + mnozina.size() + ", konkretne: " + mnozina.toString());
        
        mnozina.remove(new Vertex(123, 123)); //navratove hodnoty add, remove, ...
        System.out.println("Pocet prvkov: " + mnozina.size() + ", konkretne: " + mnozina.toString());
        
        System.out.println("Obsahuje dany prvok? " + mnozina.contains(new Vertex(2, 2)));
        //zase, keby sme nemali rozumne equals, dopadne to inak
        
        System.out.println("---");
        
        for (Vertex v : mnozina) { //poradie?
            System.out.println(v);
        }
        
        System.out.println("---");
        
        Iterator<Vertex> iterator = mnozina.iterator();
        while (iterator.hasNext()) {
            Vertex v = iterator.next();
            System.out.println(v);
        }
        
        return Collections.unmodifiableCollection(mnozina); //read-only view
    }
    
    
    
    public static void mainList() {
        List<Vertex> zoznam = new ArrayList<>();
        
        System.out.println("Pocet prvkov: " + zoznam.size());
        
        Vertex vertex = new Vertex(10, 10);
        zoznam.add(vertex);
        System.out.println("Pocet prvkov: " + zoznam.size() + ", konkretne: " + zoznam.toString());
        
        zoznam.add(vertex);
        System.out.println("Pocet prvkov: " + zoznam.size() + ", konkretne: " + zoznam.toString());
        //duplicity su legalne
        
        Vertex vertexDruhy = new Vertex(10, 10);
        zoznam.add(vertexDruhy);
        System.out.println("Pocet prvkov: " + zoznam.size() + ", konkretne: " + zoznam.toString());
        
        Vertex vertexTreti = new Vertex(2, 2);
        zoznam.add(vertexTreti);
        
        zoznam.remove(vertex);
        System.out.println("Pocet prvkov: " + zoznam.size() + ", konkretne: " + zoznam.toString());
        
        zoznam.remove(new Vertex(123, 123)); //navratove hodnoty add, remove, ...
        System.out.println("Pocet prvkov: " + zoznam.size() + ", konkretne: " + zoznam.toString());
        
        System.out.println("Obsahuje dany prvok? " + zoznam.contains(new Vertex(2, 2)));
        //zase, keby sme nemali rozumne equals, dopadne to inak
        
        System.out.println("Na ktorej pozicii? " + zoznam.indexOf(new Vertex(2, 2)));
        System.out.println("Na ktorej pozicii? " + zoznam.indexOf(new Vertex(42, 42)));
        
        System.out.println("---");
        
        for (Vertex v : zoznam) { //poradie? je nam jedno, chceme postupne vsetky prvky
            System.out.println(v);
        }
        
        System.out.println("---");
        
        Iterator<Vertex> iterator = zoznam.iterator();
        while (iterator.hasNext()) {
            Vertex v = iterator.next();
            System.out.println(v);
        }
        
        System.out.println("---");
        
        //list ma poradie
        for (int i = 0; i < zoznam.size(); i++) {
            System.out.println(i + ". prvok: " + zoznam.get(i));
        }
    }
    
    public static void mainMap() {
        Map<String, Vertex> map = new HashMap<>();
        
        map.put("prvy", new Vertex(0,0));
        map.put("druhy", new Vertex(1,2));
        
        map.put("prvy", new Vertex(3,5)); //prepise "prvy" (zase, kluce sa porovnavaju cez equals)
        
        System.out.println(map.toString()); //toString v Map
        
        System.out.println("---");
        
        //cez polozky mapy (tj. po celych "riadkoch" - vzdy vezme kluc aj jeho hodnotu)
        for (Map.Entry<String, Vertex> entry : map.entrySet()) {
            System.out.println(entry.getKey() + " -> " + entry.getValue().toString());
        }
        
        System.out.println("---");
        
        //cez kluce
        for (String s : map.keySet()) {
            System.out.println(s + " -> " + map.get(s));
        }
        
        System.out.println("---");
        
        //iba cez hodnoty
        for (Vertex v : map.values()) {
            System.out.println(v);
        }
    }
}
