
public class Vertex implements Comparable<Vertex>
{
    private double x;
    private double y;
    
    public Vertex(double x, double y) {
        this.x = x;
        this.y = y;
    }
    
    public double getX() {
        return x;
    }
    
    public double getY() {
        return y;
    }
    
    public String toString() {
        return "[" + x + ", " + y + "]";
    }
    
    
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Vertex)) {
            return false;
        }
        
        Vertex other = (Vertex) obj;
        return ((this.x == other.x) && (this.y == other.y));
    }
    
    @Override
    public int hashCode() {
        int hash = 7;
        hash = 47 * hash + Double.valueOf(x).hashCode();
        hash = 47 * hash + Double.valueOf(y).hashCode();
        return hash;
    }
    
    
    @Override
    public int compareTo(Vertex vertex) { //usporiadanie vrcholov podla suradnice X
        if (this.x < vertex.x) {
            return -1;
        } else if (this.x > vertex.x) {
            return 1;
        } else {
            return 0;
        }
    }
}
